local AddOnName, Core = ...

-- libs
local AceAddon				= LibStub("AceAddon-3.0")
local AceDB					= LibStub("AceDB-3.0")
local AceDBOptions			= LibStub("AceDBOptions-3.0")
local AceLocale				= LibStub("AceLocale-3.0")
local AceConfig				= LibStub('AceConfig-3.0')
local AceConfigDialog		= LibStub('AceConfigDialog-3.0')
local AceConfigRegistry		= LibStub('AceConfigRegistry-3.0')

-- global table
Core[1]				= AceAddon:NewAddon(AddOnName)
Core[2]				= AceLocale:GetLocale(AddOnName, false)
Core[3]				= {}
Core[3].Config		= AceConfigDialog:AddToBlizOptions(AddOnName, AddOnName)
Core[3].Options		= { type = 'group', args = {} }

-- register gui options table
AceConfigRegistry:RegisterOptionsTable(AddOnName, Core[3].Options)

-- slash command
SLASH_ADDON1 = "/xtramod"
SLASH_ADDON2 = "/xmod"
SlashCmdList.ADDON = function() AceConfigDialog:Open(AddOnName) end

-- #######################################

-- pointer
local AddOn = Core[1]
local A = Core[3]

-- oninitialize
function AddOn:OnInitialize()
	-- savedvariables
	local DEFAULT_SV = { global = {} }
	self.db = AceDB:New("XModDB", DEFAULT_SV, true)

	-- add options table profile
	A.Options.args.Profile							= AceDBOptions:GetOptionsTable(self.db)
	A.Options.args.Profile.order					= -1
	A.Options.args.Profile.args.reset.disabled		= true
end

-- reverse data in a table
-- arg1 = table
function AddOn:ReverseTable(arg1)
	if type(arg1) ~= 'table' then return end
	local t = {}
	for i, d in pairs(arg1) do
		if type(d) ~= 'table' then
			t[d] = i
		end
	end
	return t
end