local AddOnName = ...
local AddOn, L, A = unpack(select(2, ...))		-- Import: AddOn, AceLocale, AceGUI
local AB = AddOn:NewModule('InterruptShield')

-- Libs
local LCG = LibStub("LibCustomGlow-1.0")
local LSM = LibStub("LibSharedMedia-3.0")

-- default options
function AB:CreateDataTableOptions()
	self.data = {}
	-- texture table
	self.data.Texture = {
		["Shield_1"] = [[Interface\AddOns\]]..AddOnName..[[\media\textures\]]..self:GetName()..[[\Shield_1]],
	}
	-- interrupt spell table
	self.data.SpellIDInterruptList = {
		[1766] = { name = select(1, GetSpellInfo(1766)), isSpellPet = false, },			-- Rogue
		[2139] = { name = select(1, GetSpellInfo(2139)), isSpellPet = false, },			-- Mage
		[6552] = { name = select(1, GetSpellInfo(6552)), isSpellPet = false, },			-- Warrior
		[15487] = { name = select(1, GetSpellInfo(15487)), isSpellPet = false, },		-- Priest
		[19647] = { name = select(1, GetSpellInfo(19647)), isSpellPet = true,  },		-- Warlock
		[31935] = { name = select(1, GetSpellInfo(31935)), isSpellPet = false, },		-- Paladin
		[47476] = { name = select(1, GetSpellInfo(47476)), isSpellPet = false, },		-- Death Knight
		[47528] = { name = select(1, GetSpellInfo(47528)), isSpellPet = false, },		-- Death Knight
		[57994] = { name = select(1, GetSpellInfo(57994)), isSpellPet = false, },		-- Shaman
		[78675] = { name = select(1, GetSpellInfo(78675)), isSpellPet = false, },		-- Druid
		[96231] = { name = select(1, GetSpellInfo(96231)), isSpellPet = false, },		-- Paladin
		[106839] = { name = select(1, GetSpellInfo(106839)), isSpellPet = false, },		-- Druid
		[116705] = { name = select(1, GetSpellInfo(116705)), isSpellPet = false, },		-- Monk
		[119910] = { name = select(1, GetSpellInfo(119910)), isSpellPet = true,  },		-- Warlock
		[147362] = { name = select(1, GetSpellInfo(147362)), isSpellPet = false, },		-- Hunter
		[183752] = { name = select(1, GetSpellInfo(183752)), isSpellPet = false, },		-- Demon Hunter
		[187707] = { name = select(1, GetSpellInfo(187707)), isSpellPet = false, },		-- Hunter
		[202137] = { name = select(1, GetSpellInfo(202137)),isSpellPet = false, },		-- Demon Hunter
	}
end

-- default savedvariables
function AB:CreateSavedVariables()
	local dbo = AddOn.db.profile
	if type(dbo[self:GetName()]) ~= 'table' then dbo[self:GetName()] = {} end

	local dbo = AddOn.db.profile[self:GetName()]
	if type(dbo.ShieldTexture) ~= 'table' then dbo.ShieldTexture = {} end
	if type(dbo.InterruptMsg) ~= 'table' then dbo.InterruptMsg = {} end

	local dbo = AddOn.db.profile[self:GetName()].ShieldTexture
	if type(dbo.Enable) ~= 'boolean' then dbo.Enable = true end
	if type(dbo.Locked) ~= 'boolean' then dbo.Locked = true end
	if type(dbo.Parent) ~= 'string' then dbo.Parent = "UIParent" end
	if type(dbo.Texture) ~= 'string' then dbo.Texture = self.data.Texture.Shield_1 end
	if type(dbo.Strata) ~= 'string' then dbo.Strata = "LOW" end
	if type(dbo.Width) ~= 'number' then dbo.Width = 64 end
	if type(dbo.Height) ~= 'number' then dbo.Height = 64 end
	if type(dbo.OffsetX) ~= 'number' then dbo.OffsetX = 0 end
	if type(dbo.OffsetY) ~= 'number' then dbo.OffsetY = 0 end
	if type(dbo.GoodInterruptColor) ~= 'table' then dbo.GoodInterruptColor = {} end
	if type(dbo.GoodInterruptColor.r) ~= 'number' then dbo.GoodInterruptColor.r = 0 end
	if type(dbo.GoodInterruptColor.g) ~= 'number' then dbo.GoodInterruptColor.g = 1 end
	if type(dbo.GoodInterruptColor.b) ~= 'number' then dbo.GoodInterruptColor.b = 0 end
	if type(dbo.BadInterruptColor) ~= 'table' then dbo.BadInterruptColor = {} end
	if type(dbo.BadInterruptColor.r) ~= 'number' then dbo.BadInterruptColor.r = 1 end
	if type(dbo.BadInterruptColor.g) ~= 'number' then dbo.BadInterruptColor.g = 0 end
	if type(dbo.BadInterruptColor.b) ~= 'number' then dbo.BadInterruptColor.b = 0 end
	if type(dbo.Glow) ~= 'table' then dbo.Glow = {} end
	if type(dbo.Glow.Enable) ~= 'boolean' then dbo.Glow.Enable = true end
	if type(dbo.Glow.Type) ~= 'string' then dbo.Glow.Type = LCG.glowList[2] end
	if type(dbo.Glow.Color) ~= 'table' then dbo.Glow.Color = {} end
	if type(dbo.Glow.Color.r) ~= 'number' then dbo.Glow.Color.r = 0 end
	if type(dbo.Glow.Color.g) ~= 'number' then dbo.Glow.Color.g = 1 end
	if type(dbo.Glow.Color.b) ~= 'number' then dbo.Glow.Color.b = 0 end

	local dbo = AddOn.db.profile[self:GetName()].InterruptMsg
	if type(dbo.Enable) ~= 'boolean' then dbo.Enable = true end
	if type(dbo.Channel) ~= 'string' then dbo.Channel = "SAY" end
	if type(dbo.AnnounceInSolo) ~= 'boolean' then dbo.AnnounceInSolo = false end
	if type(dbo.AnnounceAnotherPlayer) ~= 'boolean' then dbo.AnnounceAnotherPlayer = false end

	local dbo = AddOn.db.profile[self:GetName()]
	self.db = dbo
end

-- default gui options
function AB:CreateDataTableGUIOptions()
	local screenWidth = math.ceil(GetScreenWidth() / 20) * 20
	local screenHeight = math.ceil(GetScreenHeight() / 20) * 20
	local DEFAULT = {
		type = 'group',
		name = self:GetName(),
		order = 3,
		args = {
			ShieldTexture = {
				type = 'group',
				name = L.is_gui_shieldtexture,
				inline = true,
				order = 1,
				args = {
					Enable = {
						order = 1,
						type = 'toggle',
						name = L.is_gui_shieldtexture_enable,
						desc = L.is_gui_ShieldTexture_enable_desc,
						get = function() return self.db.ShieldTexture.Enable end,
						set = function(_, value) self.db.ShieldTexture.Enable = value end,
					},
					Locked = {
						order = 2,
						type = 'execute',
						name = L.is_gui_shieldtexture_locked,
						desc = L.is_gui_ShieldTexture_locked_desc,
						func = function()
							if self.db.ShieldTexture.Locked == true then
								self.db.ShieldTexture.Locked = false
							else
								self.db.ShieldTexture.Locked = true
							end
						end,
					},
					Parent = {
						order = 3,
						type = 'input',
						name = L.is_gui_shieldtexture_parent,
						desc = L.is_gui_ShieldTexture_parent_desc,
						disabled = function() return not self.db.ShieldTexture.Enable end,
						get = function() return self.db.ShieldTexture.Parent end,
						set = function(_, value) self.db.ShieldTexture.Parent = value end,
					},
					Texture = {
						order = 4,
						type = 'select',
						name = L.is_gui_shieldtexture_texture,
						desc = L.is_gui_shieldtexture_texture_desc,
						disabled = function() return not self.db.ShieldTexture.Enable end,
						get = function() return self.db.ShieldTexture.Texture end,
						set = function(_, value) self.db.ShieldTexture.Texture = value end,
						values = AddOn:ReverseTable(self.data.Texture)
					},
					Strata = {
						order = 5,
						type = 'select',
						name = L.is_gui_shieldtexture_strata,
						desc = L.is_gui_shieldtexture_strata_desc,
						disabled = function() return not self.db.ShieldTexture.Enable end,
						get = function() return self.db.ShieldTexture.Strata end,
						set = function(_, value) self.db.ShieldTexture.Strata = value end,
						values = {
							["BACKGROUND"] = "· BACKGROUND",
							["LOW"] = "· LOW",
							["MEDIUM"] = "· MEDIUM",
							["HIGH"] = "· HIGH",
							["TOOLTIP"] = "· TOOLTIP",
						},
					},
					Width = {
						order = 6,
						type = 'range',
						name = L.is_gui_shieldtexture_width,
						desc = L.is_gui_shieldtexture_width_desc,
						disabled = function() return not self.db.ShieldTexture.Enable end,
						get = function() return self.db.ShieldTexture.Width end,
						set = function(_, value) self.db.ShieldTexture.Width = value end,
						min = 1, max = screenWidth, step = 0.5,
					},
					Height = {
						order = 7,
						type = 'range',
						name = L.is_gui_shieldtexture_height,
						desc = L.is_gui_shieldtexture_height_desc,
						disabled = function() return not self.db.ShieldTexture.Enable end,
						get = function() return self.db.ShieldTexture.Height end,
						set = function(_, value) self.db.ShieldTexture.Height = value end,
						min = 1, max = screenHeight, step = 0.5,
					},
					OffsetX = {
						order = 8,
						type = 'range',
						name = L.is_gui_shieldtexture_offsetx,
						desc = L.is_gui_shieldtexture_offsetx_desc,
						disabled = function() return not self.db.ShieldTexture.Enable end,
						get = function() return self.db.ShieldTexture.OffsetX end,
						set = function(_, value) self.db.ShieldTexture.OffsetX = value end,
						min = -screenWidth, max = screenWidth, step = 0.5,
					},
					OffsetY = {
						order = 9,
						type = 'range',
						name = L.is_gui_shieldtexture_offsety,
						desc = L.is_gui_shieldtexture_offsety_desc,
						disabled = function() return not self.db.ShieldTexture.Enable end,
						get = function() return self.db.ShieldTexture.OffsetY end,
						set = function(_, value) self.db.ShieldTexture.OffsetY = value end,
						min = -screenHeight, max = screenHeight, step = 0.5,
					},
					Separate0 = {
						order = 10,
						type = 'header',
						name = "",
					},
					GoodInterruptColor = {
						type = 'color',
						order = 11,
						name = L.is_gui_shieldtexture_goodinterruptcolor,
						desc = L.is_gui_shieldtexture_goodinterruptcolor_desc,
						hasAlpha = false,
						disabled = function() return not self.db.ShieldTexture.Enable end,
						get = function() return self.db.ShieldTexture.GoodInterruptColor.r, self.db.ShieldTexture.GoodInterruptColor.g, self.db.ShieldTexture.GoodInterruptColor.b end,
						set = function(_, red, green, blue)
							self.db.ShieldTexture.GoodInterruptColor.r = red
							self.db.ShieldTexture.GoodInterruptColor.g = green
							self.db.ShieldTexture.GoodInterruptColor.b = blue
						end,
					},
					BadInterruptColor = {
						type = 'color',
						order = 12,
						name = L.is_gui_shieldtexture_badinterruptcolor,
						desc = L.is_gui_shieldtexture_badinterruptcolor_desc,
						hasAlpha = false,
						disabled = function() return not self.db.ShieldTexture.Enable end,
						get = function() return self.db.ShieldTexture.BadInterruptColor.r, self.db.ShieldTexture.BadInterruptColor.g, self.db.ShieldTexture.BadInterruptColor.b end,
						set = function(_, red, green, blue)
							self.db.ShieldTexture.BadInterruptColor.r = red
							self.db.ShieldTexture.BadInterruptColor.g = green
							self.db.ShieldTexture.BadInterruptColor.b = blue
						end,
					},
					Separate1 = {
						order = 13,
						type = 'header',
						name = "",
					},
					GlowEnable = {
						order = 14,
						type = 'toggle',
						name = L.is_gui_shieldtexture_glowenable,
						desc = L.is_gui_shieldtexture_glowenable_desc,
						disabled = function() return not self.db.ShieldTexture.Enable end,
						get = function() return self.db.ShieldTexture.Glow.Enable end,
						set = function(_, value) self.db.ShieldTexture.Glow.Enable = value end,
					},
					GlowType = {
						order = 15,
						type = 'select',
						name = L.is_gui_shieldtexture_glowtype,
						desc = L.is_gui_shieldtexture_glowtype_desc,
						hidden = function() return not self.db.ShieldTexture.Glow.Enable end,
						disabled = function() return not self.db.ShieldTexture.Enable end,
						get = function() return self.db.ShieldTexture.Glow.Type end,
						set = function(_, value) self.db.ShieldTexture.Glow.Type = value end,
						values = {
							[LCG.glowList[1]] = "· "..LCG.glowList[1],
							[LCG.glowList[2]] = "· "..LCG.glowList[2],
							[LCG.glowList[3]] = "· "..LCG.glowList[3],
						},
					},
					GlowColor = {
						type = 'color',
						order = 16,
						name = L.is_gui_shieldtexture_glowcolor,
						desc = L.is_gui_shieldtexture_glowcolor_desc,
						hasAlpha = false,
						hidden = function() return not self.db.ShieldTexture.Glow.Enable end,
						disabled = function() return not self.db.ShieldTexture.Enable end,
						get = function() return self.db.ShieldTexture.Glow.Color.r, self.db.ShieldTexture.Glow.Color.g, self.db.ShieldTexture.Glow.Color.b end,
						set = function(_, red, green, blue)
							self.db.ShieldTexture.Glow.Color.r = red
							self.db.ShieldTexture.Glow.Color.g = green
							self.db.ShieldTexture.Glow.Color.b = blue
						end,
					},
				},
			},
			InterruptMsg = {
				type = 'group',
				name = L.is_gui_interruptmsg,
				inline = true,
				order = 2,
				args = {
					Enable = {
						order = 1,
						type = 'toggle',
						name = L.is_gui_interruptmsg_enable,
						desc = L.is_gui_interruptmsg_enable_desc,
						get = function() return self.db.InterruptMsg.Enable end,
						set = function(_, value) self.db.InterruptMsg.Enable = value end,
					},
					Channel = {
						order = 2,
						type = 'select',
						name = L.is_gui_interruptmsg_channel,
						desc = L.is_gui_interruptmsg_channel_desc,
						disabled = function() return not self.db.InterruptMsg.Enable end,
						get = function() return self.db.InterruptMsg.Channel end,
						set = function(_, value) self.db.InterruptMsg.Channel = value end,
						values = {
							["SAY"] = L.is_gui_interruptmsg_channel_say,
							["YELL"] = L.is_gui_interruptmsg_channel_yell,
						},
					},
					AnnounceInSolo = {
						order = 3,
						type = 'toggle',
						name = L.is_gui_interruptmsg_announceinsolo,
						desc = L.is_gui_interruptmsg_announceinsolo_desc,
						disabled = function() return not self.db.InterruptMsg.Enable end,
						get = function() return self.db.InterruptMsg.AnnounceInSolo end,
						set = function(_, value) self.db.InterruptMsg.AnnounceInSolo = value end,
					},
					AnnounceAnotherPlayer = {
						order = 4,
						type = 'toggle',
						name = L.is_gui_interruptmsg_announceanotherplayer,
						desc = L.is_gui_interruptmsg_announceanotherplayer_desc,
						disabled = function() return not self.db.InterruptMsg.Enable end,
						get = function() return self.db.InterruptMsg.AnnounceAnotherPlayer end,
						set = function(_, value) self.db.InterruptMsg.AnnounceAnotherPlayer = value end,
					},
				},
			},
		},
	}
	A.Options.args[self:GetName()] = DEFAULT
end

-- #######################################
-- #######################################

-- oninitialize
function AB:OnInitialize()
	self:CreateDataTableOptions()
	self:CreateSavedVariables()
	self:CreateDataTableGUIOptions()

	-- Learning interruption spells
	function LearningSpellInterrupt(sourceGUID, sourceSpellID)
		if not sourceGUID and sourceSpellID then return end
		if self.data.SpellIDInterruptList[sourceSpellID] then return end
		if not self.db.LearningSpellInterrupt then self.db.LearningSpellInterrupt = {} end
		if self.db.LearningSpellInterrupt[sourceSpellID] then return end
		if not self.db.LearningSpellInterrupt[sourceSpellID] then self.db.LearningSpellInterrupt[sourceSpellID] = {} end
		local unit = strsplit("-",sourceGUID)
		if unit == "Player" then
			self.db.LearningSpellInterrupt[sourceSpellID].name = select(1, GetSpellInfo(sourceSpellID))
			self.db.LearningSpellInterrupt[sourceSpellID].isSpellPet = false
		elseif unit == "Pet" then
			self.db.LearningSpellInterrupt[sourceSpellID].name = select(1, GetSpellInfo(sourceSpellID))
			self.db.LearningSpellInterrupt[sourceSpellID].isSpellPet = true
		end
		print("|cffffd200"..AddOnName..": |cffffffff"..L.is_interruptlearnedspell.."|r")
	end

	-- return true or false
	-- If the interrupt spell is known and available
	function GetSpellInterruptCooldown()
		local result = false
		for id, _ in pairs(self.data.SpellIDInterruptList) do
			local SpellIsKnown = IsSpellKnown(id, self.data.SpellIDInterruptList[id].isSpellPet)
			if SpellIsKnown == true then
				local cur, _, _ = GetSpellCooldown(id)
				if cur == 0 then
					result = true
				end
			end
		end
		if type(self.db.LearningSpellInterrupt) == 'table' then
			for id, _ in pairs(self.db.LearningSpellInterrupt) do
				local SpellIsKnown = IsSpellKnown(id, self.db.LearningSpellInterrupt[id].isSpellPet)
				if SpellIsKnown == true then
					local cur, _, _ = GetSpellCooldown(id)
					if cur == 0 then
						result = true
					end
				end
			end
		end
		return result
	end

	-- return true, false or nil
	-- If the current target can not be interrupted
	function GetSpellInterruptTarget()
		local result = select(7, UnitChannelInfo("target")) or select(8, UnitCastingInfo("target"))
		return result
	end

	-- frameonupdate
	function FrameOnUpdate(frame)
		local db = self.db.ShieldTexture
		frame:SetParent(_G[db.Parent])
		frame:SetFrameStrata(db.Strata)
		frame:SetHeight(db.Height)
		frame:SetWidth(db.Width)
		frame:SetPoint("CENTER", db.OffsetX, db.OffsetY)
		frame.Texture:SetTexture(db.Texture)
		frame.Texture:SetAllPoints(frame)
		frame.Texture:SetDesaturated(true)
		if db.Locked == false then
			if InCombatLockdown() == true then db.Locked = true end
			frame.Texture:SetVertexColor(db.GoodInterruptColor.r, db.GoodInterruptColor.g, db.GoodInterruptColor.b)
			frame.Texture:SetAlpha(1)
		elseif db.Enable == true and UnitExists("target") == true and UnitIsEnemy("player","target") == true then
			local IsNotInterruptible = GetSpellInterruptTarget()
			if IsNotInterruptible == true then
				LCG.stopList[db.Glow.Type](frame)
				frame.Texture:SetVertexColor(db.BadInterruptColor.r, db.BadInterruptColor.g, db.BadInterruptColor.b)
				frame.Texture:SetAlpha(1)
			elseif IsNotInterruptible == false then
				if db.Glow.Enable == true and GetSpellInterruptCooldown() == true then
					LCG.startList[db.Glow.Type](frame, {db.Glow.Color.r, db.Glow.Color.g, db.Glow.Color.b, db.Glow.Color.a})
				end
				frame.Texture:SetVertexColor(db.GoodInterruptColor.r, db.GoodInterruptColor.g, db.GoodInterruptColor.b)
				frame.Texture:SetAlpha(1)
			else
				LCG.stopList[db.Glow.Type](frame)
				frame.Texture:SetAlpha(0)
			end
		else
			LCG.stopList[db.Glow.Type](frame)
			frame.Texture:SetAlpha(0)
		end
	end

	-- frameonevent
	function FrameOnEvent(arg1, arg2)
		-- COMBAT_LOG_EVENT_UNFILTERED
		if arg2 == "COMBAT_LOG_EVENT_UNFILTERED" then
			local db = self.db.InterruptMsg
			local _, event, _, sourceGUID, sourceName, _, _, _, destName, _, _, sourceSpellID, _, _, destSpellID = CombatLogGetCurrentEventInfo()
			if event == "SPELL_INTERRUPT" and db.Enable == true then
				LearningSpellInterrupt(sourceGUID, sourceSpellID)
				local inGroup, inRaid, inPartyLFG = IsInGroup(), IsInRaid(), IsPartyLFG()
				local sourceSpellLink = GetSpellLink(sourceSpellID)
				local destSpellLink = GetSpellLink(destSpellID)
				if inGroup == true or inRaid == true or inPartyLFG == true or db.AnnounceInSolo == true then
					if sourceName ~= UnitName("player") and db.AnnounceAnotherPlayer == false then return end
					if sourceName ~= UnitName("player") and GetNumGroupMembers() == 0 then return end
					SendChatMessage(format(L.is_interruptmsg, sourceName, destSpellLink, destName, sourceSpellLink), db.Channel, "COMMON")
				end
			end
		end
	end

	local Frame = CreateFrame("Frame")
	local ShieldTexture = Frame:CreateTexture()
	Frame.Texture = ShieldTexture
	Frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	Frame:SetScript("OnEvent", FrameOnEvent)
	Frame:SetScript("OnUpdate", FrameOnUpdate)
end