local AddOnName = ...
local AddOn, L, A = unpack(select(2, ...))					-- Import: AddOn, AceLocale, AceGUI
local AB = AddOn:NewModule('PlayerRealm')

-- default module options
function AB:CreateDataTableOptions()
	-- create table
	self.data = {}
	-- realmlist table
	local FlagPath = [[Interface\AddOns\]]..AddOnName..[[\media\textures\]]..self:GetName()
	self.data.RealmList = {
		-- # EU Server : https://worldofwarcraft.com/en-GB/game/status
		-- # France 37
		["Arakarahm"]				= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Arathi"]					= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Archimonde"]				= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Chantséternels"]			= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Cho'gall"]				= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["ConfrérieduThorium"]		= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["ConseildesOmbres"]		= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["CultedelaRivenoire"]		= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Dalaran"]					= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Drek'Thar"]				= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Eitrigg"]					= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Eldre'Thalas"]			= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Elune"]					= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Garona"]					= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Hyjal"]					= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Illidan"]					= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Kael'thas"]				= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["KhazModan"]				= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["KirinTor"]				= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Krasus"]					= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["LaCroisadeécarlate"]		= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["LesClairvoyants"]			= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["LesSentinelles"]			= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["MarécagedeZangar"]		= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Medivh"]					= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Naxxramas"]				= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Ner'zhul"]				= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Rashgarroth"]				= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Sargeras"]				= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Sinstralis"]				= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Suramar"]					= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Templenoir"]				= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Throk'Feroth"]			= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Uldaman"]					= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Varimathras"]				= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Vol'jin"]					= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		["Ysondre"]					= { ["Locale"] = "frFR",	["Texture"] = FlagPath..[[\frFR]],	["Region"] = L.prm_france,		["SubRegion"] = nil, },
		-- # Germany 87
		["Aegwynn"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Alexstrasza"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Alleria"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Aman'Thul"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Ambossar"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Anetheron"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Antonidas"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Anub'arak"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Area52"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Arthas"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Arygos"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Azshara"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Baelgun"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Blackhand"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Blackmoore"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Blackrock"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Blutkessel"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Dalvengyr"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["DasKonsortium"]			= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["DasSyndikat"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["DerMithrilorden"]			= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["DerRatvonDalaran"]		= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["DerAbyssischeRat"]		= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Destromath"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Dethecus"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["DieAldor"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["DieNachtwache"]			= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["DieSilberneHand"]			= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["DieTodeskrallen"]			= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["DieewigeWacht"]			= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["DunMorogh"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Durotan"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Echsenkessel"]			= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Eredar"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["FestungderStürme"]		= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Forscherliga"]			= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Frostmourne"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Frostwolf"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Garrosh"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Gilneas"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Gorgonnash"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Gul'dan"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Kargath"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Kel'Thuzad"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Khaz'goroth"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Kil'jaeden"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Krag'jin"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["KultderVerdammten"]		= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["LaVeilled'Argus"]			= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Lordaeron"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Lothar"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Madmortem"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Mal'Ganis"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Malfurion"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Malorne"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Malygos"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Mannoroth"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Mug'thol"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Nathrezim"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Nazjatar"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Nefarian"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Nera'thor"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Nethersturm"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Norgannon"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Nozdormu"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Onyxia"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Perenolde"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Proudmoore"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Rajaxx"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Rexxar"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Sen'jin"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Shattrath"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Taerar"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Teldrassil"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Terrordar"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Theradras"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Thrall"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Tichondrius"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Tirion"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Todeswache"]				= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Ulduar"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Un'Goro"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Vek'lor"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Wrathbringer"]			= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Ysera"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["ZirkeldesCenarius"]		= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		["Zuluhed"]					= { ["Locale"] = "deDE",	["Texture"] = FlagPath..[[\deDE]],	["Region"] = L.prm_germany,		["SubRegion"] = nil, },
		-- # Italy 2
		["Nemesis"]					= { ["Locale"] = "itIT",	["Texture"] = FlagPath..[[\itIT]],	["Region"] = L.prm_italy,		["SubRegion"] = nil, },
		["Pozzodell'Eternità"]		= { ["Locale"] = "itIT",	["Texture"] = FlagPath..[[\itIT]],	["Region"] = L.prm_italy,		["SubRegion"] = nil, },
		-- # Portugal 1
		["Aggra(Português)"]		= { ["Locale"] = "ptPT",	["Texture"] = FlagPath..[[\ptPT]],	["Region"] = L.prm_portugal,	["SubRegion"] = nil, },
		-- # Russia 20
		["Ясеневыйлес"]				= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["Азурегос"]				= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["ЧерныйШрам"]				= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["ПиратскаяБухта"]			= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["Борейскаятундра"]			= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["СтражСмерти"]				= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["ТкачСмерти"]				= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["Подземье"]				= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["ВечнаяПесня"]				= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["Дракономор"]				= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["Галакронд"]				= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["Голдринн"]				= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["Гордунни"]				= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["Седогрив"]				= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["Гром"]					= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["Ревущийфьорд"]			= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["Корольлич"]				= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["Разувий"]					= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["СвежевательДуш"]			= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		["Термоштепсель"]			= { ["Locale"] = "ruRU",	["Texture"] = FlagPath..[[\ruRU]],	["Region"] = L.prm_russia,		["SubRegion"] = nil, },
		-- # Spain 11
		["C'Thun"]					= { ["Locale"] = "esES",	["Texture"] = FlagPath..[[\esES]],	["Region"] = L.prm_spain,		["SubRegion"] = nil, },
		["ColinasPardas"]			= { ["Locale"] = "esES",	["Texture"] = FlagPath..[[\esES]],	["Region"] = L.prm_spain,		["SubRegion"] = nil, },
		["DunModr"]					= { ["Locale"] = "esES",	["Texture"] = FlagPath..[[\esES]],	["Region"] = L.prm_spain,		["SubRegion"] = nil, },
		["Exodar"]					= { ["Locale"] = "esES",	["Texture"] = FlagPath..[[\esES]],	["Region"] = L.prm_spain,		["SubRegion"] = nil, },
		["LosErrantes"]				= { ["Locale"] = "esES",	["Texture"] = FlagPath..[[\esES]],	["Region"] = L.prm_spain,		["SubRegion"] = nil, },
		["Minahonda"]				= { ["Locale"] = "esES",	["Texture"] = FlagPath..[[\esES]],	["Region"] = L.prm_spain,		["SubRegion"] = nil, },
		["Sanguino"]				= { ["Locale"] = "esES",	["Texture"] = FlagPath..[[\esES]],	["Region"] = L.prm_spain,		["SubRegion"] = nil, },
		["Shen'dralar"]				= { ["Locale"] = "esES",	["Texture"] = FlagPath..[[\esES]],	["Region"] = L.prm_spain,		["SubRegion"] = nil, },
		["Tyrande"]					= { ["Locale"] = "esES",	["Texture"] = FlagPath..[[\esES]],	["Region"] = L.prm_spain,		["SubRegion"] = nil, },
		["Uldum"]					= { ["Locale"] = "esES",	["Texture"] = FlagPath..[[\esES]],	["Region"] = L.prm_spain,		["SubRegion"] = nil, },
		["Zul'jin"]					= { ["Locale"] = "esES",	["Texture"] = FlagPath..[[\esES]],	["Region"] = L.prm_spain,		["SubRegion"] = nil, },
		-- # England 109
		["AeriePeak"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Agamaggan"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Aggramar"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Ahn'Qiraj"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Al'Akir"]					= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Alonsus"]					= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Anachronos"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Arathor"]					= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["ArgentDawn"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Aszune"]					= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Auchindoun"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["AzjolNerub"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Azuremyst"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Balnazzar"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Blade'sEdge"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Bladefist"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Bloodfeather"]			= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Bloodhoof"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Bloodscalp"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Boulderfist"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["BronzeDragonflight"]		= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Bronzebeard"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["BurningBlade"]			= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["BurningLegion"]			= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["BurningSteppes"]			= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["ChamberofAspects"]		= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Chromaggus"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Crushridge"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Daggerspine"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["DarkmoonFaire"]			= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Darksorrow"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Darkspear"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Deathwing"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["DefiasBrotherhood"]		= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Dentarg"]					= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Doomhammer"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Draenor"]					= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Dragonblight"]			= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Dragonmaw"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Drak'thul"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Dunemaul"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["EarthenRing"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["EmeraldDream"]			= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Emeriss"]					= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Eonar"]					= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Executus"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Frostmane"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Frostwhisper"]			= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Genjuros"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Ghostlands"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["GrimBatol"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Hakkar"]					= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Haomarush"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Hellfire"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Hellscream"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Jaedenar"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Karazhan"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Kazzak"]					= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Khadgar"]					= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Kilrogg"]					= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Kor'gall"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["KulTiras"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["LaughingSkull"]			= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Lightbringer"]			= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Lightning'sBlade"]		= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Magtheridon"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Mazrigos"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Moonglade"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Nagrand"]					= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Neptulon"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Nordrassil"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Outland"]					= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Quel'Thalas"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Ragnaros"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Ravencrest"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Ravenholdt"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Runetotem"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Saurfang"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["ScarshieldLegion"]		= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Shadowsong"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["ShatteredHalls"]			= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["ShatteredHand"]			= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Silvermoon"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Skullcrusher"]			= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Spinebreaker"]			= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Sporeggar"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["SteamwheedleCartel"]		= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Stormrage"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Stormreaver"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Stormscale"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Sunstrider"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Sylvanas"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Talnivarr"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["TarrenMill"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Terenas"]					= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Terokkar"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["TheMaelstrom"]			= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["TheSha'tar"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["TheVentureCo"]			= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Thunderhorn"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Trollbane"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Turalyon"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Twilight'sHammer"]		= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["TwistingNether"]			= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Vashj"]					= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Vek'nilash"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Wildhammer"]				= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Xavius"]					= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
		["Zenedar"]					= { ["Locale"] = "enGB",	["Texture"] = FlagPath..[[\enGB]],	["Region"] = L.prm_england,		["SubRegion"] = nil, },
	}
end

-- default savedvariables
function AB:CreateSavedVariables()
	local dbo = AddOn.db.profile
	if type(dbo[self:GetName()]) ~= 'table' then dbo[self:GetName()] = {} end

	local dbo = AddOn.db.profile[self:GetName()]
	if type(dbo.ChatFlagEnable) ~= 'boolean' then dbo.ChatFlagEnable = true end
	if type(dbo.TooltipSetUnitFlagEnable) ~= 'boolean' then dbo.TooltipSetUnitFlagEnable = true end
	if type(dbo.LFGListFinderEnable) ~= 'boolean' then dbo.LFGListFinderEnable = true end
	if type(dbo.LFGListViewerEnable) ~= 'boolean' then dbo.LFGListViewerEnable = true end

	local dbo = AddOn.db.profile[self:GetName()]
	self.db = dbo
end

-- default gui options
function AB:CreateDataTableGUIOptions()
	local DEFAULT = {
		type = 'group',
		name = self:GetName(),
		order = 1,
		args = {
			Header = {
				type = 'group',
				name = L.prm_gui_name,
				inline = true,
				order = 1,
				args = {
					ChatFlagEnable = {
						order = 1,
						type = 'toggle',
						name = L.prm_gui_chatflagenable,
						desc = L.prm_gui_chatflagenable_desc,
						get = function(info) return self.db.ChatFlagEnable end,
						set = function(info, value) self.db.ChatFlagEnable = value end,
					},
					TooltipSetUnitFlagEnable = {
						order = 2,
						type = 'toggle',
						name = L.prm_gui_tooltipsetunitflagenable,
						desc = L.prm_gui_tooltipsetunitflagenable_desc,
						get = function(info) return self.db.TooltipSetUnitFlagEnable end,
						set = function(info, value) self.db.TooltipSetUnitFlagEnable = value end,
					},
					LFGListFinderEnable = {
						order = 3,
						type = 'toggle',
						name = L.prm_gui_lfglistfinderenable,
						desc = L.prm_gui_lfglistfinderenable_desc,
						get = function(info) return self.db.LFGListFinderEnable end,
						set = function(info, value) self.db.LFGListFinderEnable = value end,
					},
					LFGListViewerEnable = {
						order = 3,
						type = 'toggle',
						name = L.prm_gui_lfglistviewerenable,
						desc = L.prm_gui_lfglistviewerenable_desc,
						get = function(info) return self.db.LFGListViewerEnable end,
						set = function(info, value) self.db.LFGListViewerEnable = value end,
					},
				},
			},
		},
	}
	A.Options.args[self:GetName()] = DEFAULT
end

-- #######################################
-- #######################################

-- oninitialize
function AB:OnInitialize()
	self:CreateDataTableOptions()
	self:CreateSavedVariables()
	self:CreateDataTableGUIOptions()

	-- return name, realm and unit
	-- arg1 = unitid or unitname or unitnameandrealm
	-- arg2 = realm
	function GetNameAndRealm(arg1, arg2)
		if not arg1 then return end
		local name, realm, unit
		if UnitExists(arg1) then
			unit = arg1
			if UnitIsPlayer(arg1) then
				name, realm = UnitName(arg1)
				realm = realm and realm ~= "" and realm or GetNormalizedRealmName()
			end
		elseif type(arg1) == "string" and arg1 ~= "" then
			if arg1:find("-", nil, true) then
				name, realm = ("-"):split(arg1)
			else
				name = arg1
			end
			if not realm or realm == "" then
				if type(arg2) == "string" and arg2 ~= "" then
					realm = arg2
				else
					realm = GetNormalizedRealmName()
				end
			end
		end
		return name, realm, unit
	end

	-- return information from realmlist
	-- arg1 = realm
	function GetLocation(arg1)
		if not arg1 then return end
		for realm, data in pairs(self.data.RealmList) do
			local newarg1, newrealm = arg1:lower(), realm:lower()
			if newarg1 == newrealm or newarg1 == newrealm:gsub("'", "’") then
				return data.Locale, data.Texture, data.Region, data.SubRegion
			end
		end
	end

	-- add location on the chat frame
	function ChatFrameLocationFilter(arg1, arg2, arg3, arg4, ...)
		if self.db.ChatFlagEnable == true then
			local _, realm, _ = GetNameAndRealm(arg4)
			if realm then
				local _, texture, _, _ = GetLocation(realm)
				if texture then
					local flag = "|T"..texture..":15:15:0:0|t "
					return false , flag..arg3, arg4, ...
				end
			end
		end
	end
	ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", ChatFrameLocationFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID", ChatFrameLocationFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_LEADER", ChatFrameLocationFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", ChatFrameLocationFilter)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY_LEADER", ChatFrameLocationFilter)

	-- add location if a player is targeted
	function GameTooltipOnTooltipSetUnit(arg1)
		local _, unitID = arg1:GetUnit()
		if not UnitIsPlayer(unitID) then return end
		if self.db.TooltipSetUnitFlagEnable == true then
			local _, realm, _ = GetNameAndRealm(unitID)
			if realm then
				local _, _, region, subregion = GetLocation(realm)
				if region and subregion then
					GameTooltip:AddLine(" ")
					GameTooltip:AddLine("|cffffd200"..L.prm_region..": |cffffffff"..region.." - "..subregion.."|r")
					GameTooltip:Show()
				elseif region then
					GameTooltip:AddLine(" ")
					GameTooltip:AddLine("|cffffd200"..L.prm_region..": |cffffffff"..region.."|r")
					GameTooltip:Show()
				end
			end
		end
	end
	GameTooltip:HookScript("OnTooltipSetUnit", GameTooltipOnTooltipSetUnit)

	-- add location lfg finder
	function LFGListUtilSetSearchFinder(arg1, arg2)
		if self.db.LFGListFinderEnable == true then
			local info = C_LFGList.GetSearchResultInfo(arg2)
			if info.leaderName then
				local _, realm, _ = GetNameAndRealm(info.leaderName)
				if realm then
					local _, _, region, subregion = GetLocation(realm)
					if region and subregion then
						arg1:AddLine(" ")
						arg1:AddLine("|cffffd200"..L.prm_region..": |cffffffff"..region.." - "..subregion.."|r")
						arg1:Show()
					elseif region then
						arg1:AddLine(" ")
						arg1:AddLine("|cffffd200"..L.prm_region..": |cffffffff"..region.."|r")
						arg1:Show()
					end
				end
			end
		end
	end
	hooksecurefunc("LFGListUtil_SetSearchEntryTooltip", LFGListUtilSetSearchFinder)

	-- add location lfg viewer
	local function LFGListUtilSetSearchViewer()
		if ( _G.LFGListApplicationViewerScrollFrameButton1 ) then
			local hook = {}
			local OnEnter, OnLeave
			function OnEnter(arg1)
				if self.db.LFGListViewerEnable == true and arg1.applicantID and arg1.Members then
					for i = 1, #arg1.Members do
						local b = arg1.Members[i]
						if not hook[b] then
							hook[b] = 1
							b:HookScript("OnEnter", OnEnter)
							b:HookScript("OnLeave", OnLeave)
						end
					end
				elseif arg1.memberIdx then
					local fullName = C_LFGList.GetApplicantMemberInfo(arg1:GetParent().applicantID, arg1.memberIdx)
					local _, realm, _ = GetNameAndRealm(fullName)
					if realm then
						local _, _, region, subregion = GetLocation(realm)
						if region and subregion then
							GameTooltip:AddLine(" ")
							GameTooltip:AddLine("|cffffd200"..L.prm_region..": |cffffffff"..region.." - "..subregion.."|r")
							GameTooltip:Show()
						elseif region then
							GameTooltip:AddLine(" ")
							GameTooltip:AddLine("|cffffd200"..L.prm_region..": |cffffffff"..region.."|r")
							GameTooltip:Show()
						end
					end
				end
			end
			function OnLeave(arg1)
				if self.db.LFGListViewerEnable == true and arg1.applicantID or arg1.memberIdx then
					GameTooltip:Hide()
				end
			end
			for i = 1, 14 do
				local b = _G["LFGListApplicationViewerScrollFrameButton" .. i]
				b:HookScript("OnEnter", OnEnter)
				b:HookScript("OnLeave", OnLeave)
			end
		end
	end
	LFGListUtilSetSearchViewer()

end