local AddOnName = ...
local AddOn, L, A = unpack(select(2, ...))		-- Import: AddOn, AceLocale, AceGUI
local AB = AddOn:NewModule('StarCursor')

-- libs
local AceGUI = LibStub('AceGUI-3.0')

-- default module options
function AB:CreateDataTableOptions()
	-- create table
	self.data = {}
	-- texture table
	self.data.Texture = {
		["Interface\\Cooldown\\starburst"] = "StarBurst",
		["Interface\\Cooldown\\star4"] = "Star",
		["Interface\\Cooldown\\ping4"] = "Ping",
		["Interface\\Timer\\Alliance-Logo"] = "Alliance",
		["Interface\\Timer\\Horde-Logo"] = "Horde",
		["Interface\\Timer\\Panda-Logo"] = "Panda",
		["Interface\\Challenges\\ChallengeMode_Medal_Bronze"] = "ChallengeMode Medal Bronze",
		["Interface\\Challenges\\ChallengeMode_Medal_Gold"] = "ChallengeMode Medal Gold ",
		["Interface\\Challenges\\ChallengeMode_Medal_Platinum"] = "ChallengeMode Medal Platinum",
		["Interface\\Challenges\\ChallengeMode_Medal_Silver"] = "ChallengeMode Medal Silver",
		["Interface\\PVPFrame\\PVP-Banner-Emblem-1"] = "Wheelchair",
		["Interface\\PVPFrame\\PVP-Banner-Emblem-2"] = "Recycle",
		["Interface\\PVPFrame\\PVP-Banner-Emblem-3"] = "Biohazard",
		["Interface\\PVPFrame\\PVP-Banner-Emblem-4"] = "Heart",
		["Interface\\PVPFrame\\PVP-Banner-Emblem-5"] = "Lightning Bolt",
		["Interface\\PVPFrame\\PVP-Banner-Emblem-6"] = "Bone",
		["Interface\\PVPFrame\\PVP-Banner-Emblem-7"] = "Glove",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-2"] = "Bull",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-3"] = "Bird Claw",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-4"] = "Canary",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-5"] = "Mushroom",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-6"] = "Cherries",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-7"] = "Ninja",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-8"] = "Dog Face",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-9"] = "Circled Drop",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-10"] = "Circled Glove",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-11"] = "Winged Blade",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-12"] = "Circled Cross",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-13"] = "Dynamite",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-14"] = "Intellect",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-15"] = "Feather",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-16"] = "Present",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-17"] = "Giant Jaws",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-18"] = "Drums",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-19"] = "Panda",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-20"] = "Crossed Clubs",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-21"] = "Skeleton Key",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-22"] = "Heart Potion",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-23"] = "Trophy",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-24"] = "Crossed Mallets",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-25"] = "Circled Cheetah",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-26"] = "Mutated Chicken",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-27"] = "Anvil",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-28"] = "Dwarf Face",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-29"] = "Brooch",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-30"] = "Spider",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-31"] = "Dual Hawks",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-32"] = "Cleaver",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-33"] = "Spiked Bull",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-34"] = "Fist of Thunder",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-35"] = "Lean Bull",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-36"] = "Mug",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-37"] = "Sliced Circle",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-38"] = "Totem",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-39"] = "Skull and Crossbones",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-40"] = "Voodoo Doll",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-41"] = "Dual Wolves",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-42"] = "Wolf",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-43"] = "Crossed Wrenches",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-44"] = "Saber-toothed Tiger",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-46"] = "Artifact Disc",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-47"] = "Dice",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-48"] = "Fish Face",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-49"] = "Crossed Axes",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-50"] = "Doughnut",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-51"] = "Human Face",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-52"] = "Eyeball",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-53"] = "Targeting Eye",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-54"] = "Monkey Face",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-55"] = "Circle Skull",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-56"] = "Tipped Glass",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-58"] = "Pile of Weapons",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-59"] = "Mushrooms",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-60"] = "Pounding Mallet",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-61"] = "Winged Mask",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-62"] = "Axe",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-63"] = "Spiked Shield",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-64"] = "The Horns",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-65"] = "Ice Cream Cone",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-66"] = "Ornate Lockbox",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-67"] = "Roasting Marshmallow",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-68"] = "Smiley Bomb",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-69"] = "Fist",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-70"] = "Spirit Wings",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-71"] = "Ornate Pipe",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-72"] = "Scarab",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-73"] = "Glowing Ball",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-74"] = "Circular Rune",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-75"] = "Tree",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-76"] = "Flower Pot",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-77"] = "Night Elf Face",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-78"] = "Nested Egg",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-79"] = "Helmed Chicken",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-80"] = "Winged Boot",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-81"] = "Skull and Cross-Wrenches",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-82"] = "Cracked Skull",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-83"] = "Rocket",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-84"] = "Wooden Whistle",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-85"] = "Cogwheel",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-86"] = "Lizard Eye",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-87"] = "Baited Hook",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-88"] = "Beast Face",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-89"] = "Talons",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-90"] = "Rabbit",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-91"] = "4-Toed Pawprint",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-92"] = "Paw",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-93"] = "Mask",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-94"] = "Spiked Helm",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-95"] = "Dog Treat",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-96"] = "Targeted Orc",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-97"] = "Bird Face",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-98"] = "Lollipop",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-99"] = "5-Toed Pawprint",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-100"] = "Frightened Cat",
		["Interface\\PVPFrame\\Icons\\PVP-Banner-Emblem-101"] = "Eagle Face",
		["Textures\\SpellActivationOverlays\\Arcane_Missiles"] = "Arcane Missiles",
		["Textures\\SpellActivationOverlays\\Arcane_Missiles_1"] = "Arcane Missiles 1",
		["Textures\\SpellActivationOverlays\\Arcane_Missiles_2"] = "Arcane Missiles 2",
		["Textures\\SpellActivationOverlays\\Arcane_Missiles_3"] = "Arcane Missiles 3",
		["Textures\\SpellActivationOverlays\\Art_of_War"] = "Art of War",
		["Textures\\SpellActivationOverlays\\Backlash_Green"] = "Backlash_Green",
		["Textures\\SpellActivationOverlays\\Bandits_Guile"] = "Bandits Guile",
		["Textures\\SpellActivationOverlays\\Blood_Surge"] = "Blood Surge",
		["Textures\\SpellActivationOverlays\\Brain_Freeze"] = "Brain Freeze",
		["Textures\\SpellActivationOverlays\\Echo_of_the_Elements"] = "Echo of the Elements",
		["Textures\\SpellActivationOverlays\\Eclipse_Moon"] = "Eclipse Moon",
		["Textures\\SpellActivationOverlays\\Eclipse_Sun"] = "Eclipse Sun",
		["Textures\\SpellActivationOverlays\\Focus_Fire"] = "Focus Fire",
		["Textures\\SpellActivationOverlays\\Frozen_Fingers"] = "Frozen Fingers",
		["Textures\\SpellActivationOverlays\\GenericArc_01"] = "Generic Arc 1",
		["Textures\\SpellActivationOverlays\\GenericArc_02"] = "Generic Arc 2",
		["Textures\\SpellActivationOverlays\\GenericArc_03"] = "Generic Arc 3",
		["Textures\\SpellActivationOverlays\\GenericArc_04"] = "Generic Arc 4",
		["Textures\\SpellActivationOverlays\\GenericArc_05"] = "Generic Arc 5",
		["Textures\\SpellActivationOverlays\\GenericArc_06"] = "Generic Arc 6",
		["Textures\\SpellActivationOverlays\\GenericTop_01"] = "Generic Top 1",
		["Textures\\SpellActivationOverlays\\GenericTop_02"] = "Generic Top 2",
		["Textures\\SpellActivationOverlays\\Grand_Crusader"] = "Grand Crusader",
		["Textures\\SpellActivationOverlays\\Hot_Streak"] = "Hot Streak",
		["Textures\\SpellActivationOverlays\\Imp_Empowerment"] = "Imp Empowerment",
		["Textures\\SpellActivationOverlays\\Imp_Empowerment_Green"] = "Imp Empowerment Green",
		["Textures\\SpellActivationOverlays\\Impact"] = "Impact",
		["Textures\\SpellActivationOverlays\\Lock_and_Load"] = "Lock and Load",
		["Textures\\SpellActivationOverlays\\Maelstrom_Weapon"] = "Maelstrom Weapon",
		["Textures\\SpellActivationOverlays\\Maelstrom_Weapon_1"] = "Maelstrom Weapon 1",
		["Textures\\SpellActivationOverlays\\Maelstrom_Weapon_2"] = "Maelstrom Weapon 2",
		["Textures\\SpellActivationOverlays\\Maelstrom_Weapon_3"] = "Maelstrom Weapon 3",
		["Textures\\SpellActivationOverlays\\Maelstrom_Weapon_4"] = "Maelstrom Weapon 4",
		["Textures\\SpellActivationOverlays\\Master_Marksman"] = "Master Marksman",
		["Textures\\SpellActivationOverlays\\Monk_BlackoutKick"] = "Monk Blackout Kick",
		["Textures\\SpellActivationOverlays\\Natures_Grace"] = "Nature's Grace",
		["Textures\\SpellActivationOverlays\\Nightfall"] = "Nightfall",
		["Textures\\SpellActivationOverlays\\Predatory_Swiftness"] = "Predatory Swiftness",
		["Textures\\SpellActivationOverlays\\Raging_Blow"] = "Raging Blow",
		["Textures\\SpellActivationOverlays\\Rime"] = "Rime",
		["Textures\\SpellActivationOverlays\\Slice_and_Dice"] = "Slice and Dice",
		["Textures\\SpellActivationOverlays\\Sudden_Death"] = "Sudden Death",
		["Textures\\SpellActivationOverlays\\Sudden_Doom"] = "Sudden Doom",
		["Textures\\SpellActivationOverlays\\Surge_of_Light"] = "Surge of Light",
		["Textures\\SpellActivationOverlays\\Sword_and_Board"] = "Sword and Board",
		["Textures\\SpellActivationOverlays\\Thrill_of_the_Hunt_1"] = "Thrill of the Hunt 1",
		["Textures\\SpellActivationOverlays\\Thrill_of_the_Hunt_2"] = "Thrill of the Hunt 2",
		["Textures\\SpellActivationOverlays\\Thrill_of_the_Hunt_3"] = "Thrill of the Hunt 3",
		["Textures\\SpellActivationOverlays\\Tooth_and_Claw"] = "Tooth and Claw",
		["Textures\\SpellActivationOverlays\\Backlash"] = "Backslash",
		["Textures\\SpellActivationOverlays\\Berserk"] = "Berserk",
		["Textures\\SpellActivationOverlays\\Blood_Boil"] = "Blood Boil",
		["Textures\\SpellActivationOverlays\\Dark_Transformation"] = "Dark Transformation",
		["Textures\\SpellActivationOverlays\\Denounce"] = "Denounce",
		["Textures\\SpellActivationOverlays\\Feral_OmenOfClarity"] = "Omen of Clarity (Feral)",
		["Textures\\SpellActivationOverlays\\Fulmination"] = "Fulmination",
		["Textures\\SpellActivationOverlays\\Fury_of_Stormrage"] = "Fury of Stormrage",
		["Textures\\SpellActivationOverlays\\Hand_of_Light"] = "Hand of Light",
		["Textures\\SpellActivationOverlays\\Killing_Machine"] = "Killing Machine",
		["Textures\\SpellActivationOverlays\\Molten_Core"] = "Molten Core",
		["Textures\\SpellActivationOverlays\\Molten_Core_Green"] = "Molten Core Green",
		["Textures\\SpellActivationOverlays\\Necropolis"] = "Necropolis",
		["Textures\\SpellActivationOverlays\\Serendipity"] = "Serendipity",
		["Textures\\SpellActivationOverlays\\Shooting_Stars"] = "Shooting Stars",
		["Textures\\SpellActivationOverlays\\Dark_Tiger"] = "Dark Tiger",
		["Textures\\SpellActivationOverlays\\Daybreak"] = "Daybreak",
		["Textures\\SpellActivationOverlays\\Monk_Ox"] = "Monk Ox",
		["Textures\\SpellActivationOverlays\\Monk_Ox_2"] = "Monk Ox 2",
		["Textures\\SpellActivationOverlays\\Monk_Ox_3"] = "Monk Ox 3",
		["Textures\\SpellActivationOverlays\\Monk_Serpent"] = "Monk Serpent",
		["Textures\\SpellActivationOverlays\\Monk_Tiger"] = "Monk Tiger",
		["Textures\\SpellActivationOverlays\\Monk_TigerPalm"] = "Monk Tiger Palm",
		["Textures\\SpellActivationOverlays\\Shadow_of_Death"] = "Shadow of Death",
		["Textures\\SpellActivationOverlays\\Shadow_Word_Insanity"] = "Shadow Word Insanity",
		["Textures\\SpellActivationOverlays\\Surge_of_Darkness"] = "Surge of Darkness",
		["Textures\\SpellActivationOverlays\\Ultimatum"] = "Ultimatum",
		["Textures\\SpellActivationOverlays\\White_Tiger"] = "White Tiger",
		["Textures\\SpellActivationOverlays\\spellActivationOverlay_0"] = "Spell Activation Overlay 0",
		["Textures\\SPELLCHAINEFFECTS\\Beam_Purple"] = "Purple Beam",
		["Textures\\SPELLCHAINEFFECTS\\Beam_Red"] = "Red Beam",
		["Textures\\SPELLCHAINEFFECTS\\Beam_RedDrops"] = "Red Drops Beam",
		["Textures\\SPELLCHAINEFFECTS\\DrainManaLightning"] = "Drain Mana Lightning",
		["Textures\\SPELLCHAINEFFECTS\\Ethereal_Ribbon_Spell"] = "Ethereal Ribbon",
		["Textures\\SPELLCHAINEFFECTS\\Ghost1_Chain"] = "Ghost Chain",
		["Textures\\SPELLCHAINEFFECTS\\Ghost2purple_Chain"] = "Purple Ghost Chain",
		["Textures\\SPELLCHAINEFFECTS\\HealBeam"] = "Heal Beam",
		["Textures\\SPELLCHAINEFFECTS\\Lightning"] = "Lightning",
		["Textures\\SPELLCHAINEFFECTS\\LightningRed"] = "Red Lightning",
		["Textures\\SPELLCHAINEFFECTS\\ManaBeam"] = "Mana Beam",
		["Textures\\SPELLCHAINEFFECTS\\ManaBurnBeam"] = "Mana Burn Beam",
		["Textures\\SPELLCHAINEFFECTS\\RopeBeam"] = "Rope",
		["Textures\\SPELLCHAINEFFECTS\\ShockLightning"] = "Shock Lightning",
		["Textures\\SPELLCHAINEFFECTS\\SoulBeam"] = "Soul Beam",
		["Spells\\Agility_128"] = "Paw",
		["Spells\\ArrowFeather01"] = "Feathers",
		["Spells\\Aspect_Beast"] = "Lion",
		["Spells\\Aspect_Cheetah"] = "Cheetah",
		["Spells\\Aspect_Hawk"] = "Hawk",
		["Spells\\Aspect_Monkey"] = "Monkey",
		["Spells\\Aspect_Snake"] = "Snake",
		["Spells\\Aspect_Wolf"] = "Wolf",
		["Spells\\EndlessRage"] = "Rage",
		["Spells\\Eye"] = "Eye",
		["Spells\\Eyes"] = "Eyes",
		["Spells\\Fire_Rune_128"] = "Fire",
		["Spells\\HolyRuinProtect"] = "Holy Ruin",
		["Spells\\Intellect_128"] = "Intellect",
		["Spells\\MoonCrescentGlow2"] = "Crescent",
		["Spells\\Nature_Rune_128"] = "Leaf",
		["Spells\\PROTECT_128"] = "Shield",
		["Spells\\Ice_Rune_128"] = "Snowflake",
		["Spells\\PoisonSkull1"] = "Poison Skull",
		["Spells\\InnerFire_Rune_128"] = "Inner Fire",
		["Spells\\RapidFire_Rune_128"] = "Rapid Fire",
		["Spells\\Rampage"] = "Rampage",
		["Spells\\Reticle_128"] = "Reticle",
		["Spells\\Stamina_128"] = "Bull",
		["Spells\\Strength_128"] = "Crossed Swords",
		["Spells\\StunWhirl_reverse"] = "Stun Whirl",
		["Spells\\T_Star3"] = "Star",
		["Spells\\Spirit1"] = "Spirit",
		["Spells\\starrune"] = "Star Rune",
		["Spells\\RUNEBC1"] = "Heavy BC Rune",
		["Spells\\RuneBC2"] = "Light BC Rune",
		["Spells\\RUNEFROST"] = "Circular Frost Rune",
		["Spells\\Rune1d_White"] = "Dense Circular Rune",
		["Spells\\RUNE1D_GLOWLESS"] = "Sparse Circular Rune",
		["Spells\\Rune1d"] = "Ringed Circular Rune",
		["Spells\\Rune1c"] = "Filled Circular Rune",
		["Spells\\RogueRune1"] = "Dual Blades",
		["Spells\\RogueRune2"] = "Octagonal Skulls",
		["Spells\\HOLY_RUNE1"] = "Holy Rune",
		["Spells\\Holy_Rune_128"] = "Holy Cross Rune",
		["Spells\\DemonRune5backup"] = "Demon Rune",
		["Spells\\DemonRune6"] = "Demon Rune",
		["Spells\\DemonRune7"] = "Demon Rune",
		["Spells\\DemonicRuneSummon01"] = "Demonic Summon",
		["Spells\\Death_Rune"] = "Death Rune",
		["Spells\\DarkSummon"] = "Dark Summon",
		["Spells\\AuraRune256b"] = "Square Aura Rune",
		["Spells\\AURARUNE256"] = "Ringed Aura Rune",
		["Spells\\AURARUNE8"] = "Spike-Ringed Aura Rune",
		["Spells\\AuraRune7"] = "Tri-Circle Ringed Aura Rune",
		["Spells\\AuraRune5Green"] = "Tri-Circle Aura Rune",
		["Spells\\AURARUNE_C"] = "Oblong Aura Rune",
		["Spells\\AURARUNE_B"] = "Sliced Aura Rune",
		["Spells\\AURARUNE_A"] = "Small Tri-Circle Aura Rune",
		["Spells\\TEXTURES\\Beam_ChainGold"] = "Gold Chain",
		["Spells\\TEXTURES\\Beam_ChainIron"] = "Iron Chain",
		["Spells\\TEXTURES\\Beam_FireGreen"] = "Green Fire Beam",
		["Spells\\TEXTURES\\Beam_FireRed"] = "Red Fire Beam",
		["Spells\\TEXTURES\\Beam_Purple_02"] = "Straight Purple Beam",
		["Spells\\TEXTURES\\Beam_Shadow_01"] = "Shadow Beam",
		["Spells\\TEXTURES\\Beam_SmokeBrown"] = "Brown Smoke Beam",
		["Spells\\TEXTURES\\Beam_SmokeGrey"] = "Grey Smoke Beam",
		["Spells\\TEXTURES\\Beam_SpiritLink"] = "Spirit Link Beam",
		["Spells\\TEXTURES\\Beam_SummonGargoyle"] = "Summon Gargoyle Beam",
		["Spells\\TEXTURES\\Beam_VineGreen"] = "Green Vine",
		["Spells\\TEXTURES\\Beam_VineRed"] = "Red Vine",
		["Spells\\TEXTURES\\Beam_WaterBlue"] = "Blue Water Beam",
		["Spells\\TEXTURES\\Beam_WaterGreen"] = "Green Water Beam",
	}
end

-- default savedvariables
function AB:CreateSavedVariables()
	local dbo = AddOn.db.profile
	if type(dbo[self:GetName()]) ~= 'table' then dbo[self:GetName()] = {} end
	local dbo = AddOn.db.profile[self:GetName()]
	if type(dbo.Enable) ~= 'boolean' then dbo.Enable = true end
	if type(dbo.Desaturated) ~= 'boolean' then dbo.Desaturated = true end
	if type(dbo.ClassColor) ~= 'boolean' then dbo.ClassColor = true end
	if type(dbo.Texture) ~= 'string' then dbo.Texture = "Interface\\Cooldown\\ping4" end
	if type(dbo.Strata) ~= 'string' then dbo.Strata = "TOOLTIP" end
	if type(dbo.Blend) ~= 'string' then dbo.Blend = "ADD" end
	if type(dbo.Color) ~= 'table' then dbo.Color = {} end
	if type(dbo.Color.r) ~= 'number' then dbo.Color.r = 1 end
	if type(dbo.Color.g) ~= 'number' then dbo.Color.g = 1 end
	if type(dbo.Color.b) ~= 'number' then dbo.Color.b = 0 end
	if type(dbo.Color.a) ~= 'number' then dbo.Color.a = 1 end
	local dbo = AddOn.db.profile[self:GetName()]
	self.db = dbo
end

-- default gui options
function AB:CreateDataTableGUIOptions()
	local DEFAULT_OT = {
		type = 'group',
		name = self:GetName(),
		order = 2,
		args = {
			Header = {
				order = 1,
				type = 'group',
				name = L.sc_gui_name,
				inline = true,
				args = {
					Enable = {
						order = 1,
						type = 'toggle',
						name = L.sc_gui_enable,
						desc = L.sc_gui_enable_desc,
						get = function() return self.db.Enable end,
						set = function(_, value) self.db.Enable = value end,
					},
					Desaturated = {
						order = 2,
						type = 'toggle',
						name = L.sc_gui_desaturated,
						desc = L.sc_gui_desaturated_desc,
						disabled = function() return not self.db.Enable or self.db.ClassColor end,
						get = function() return self.db.Desaturated end,
						set = function(_, value) self.db.Desaturated = value end,
					},
					ClassColor = {
						order = 3,
						type = 'toggle',
						name = L.sc_gui_classcolor,
						desc = L.sc_gui_classcolor_desc,
						disabled = function() return not self.db.Enable end,
						get = function() return self.db.ClassColor end,
						set = function(_, value) self.db.ClassColor = value end,
					},
					Texture = {
						order = 4,
						type = 'execute',
						name = L.sc_gui_texture,
						desc = L.sc_gui_texture_desc,
						disabled = function() return not self.db.Enable end,
						func = function() self:SetTexture() end,
					},
					Strata = {
						order = 5,
						type = 'select',
						name = L.sc_gui_strata,
						desc = L.sc_gui_strata_desc,
						disabled = function() return not self.db.Enable end,
						get = function() return self.db.Strata end,
						set = function(_, value) self.db.Strata = value end,
						values = {
							["BACKGROUND"] = "· BACKGROUND",
							["LOW"] = "· LOW",
							["MEDIUM"] = "· MEDIUM",
							["HIGH"] = "· HIGH",
							["TOOLTIP"] = "· TOOLTIP",
						},
					},
					Blend = {
						order = 6,
						type = 'select',
						name = L.sc_gui_blend,
						desc = L.sc_gui_blend_desc,
						disabled = function() return not self.db.Enable end,
						get = function() return self.db.Blend end,
						set = function(_, value) self.db.Blend = value end,
						values = {
							["DISABLE"] = "· DISABLE",
							["BLEND"] = "· BLEND",
							["ALPHAKEY"] = "· ALPHAKEY",
							["ADD"] = "· ADD",
							["MOD"] = "· MOD",
						},
					},
					Color = {
						type = 'color',
						order = 7,
						name = L.sc_gui_colors,
						desc = L.sc_gui_colors_desc,
						hasAlpha = true,
						disabled = function() return not self.db.Enable or self.db.ClassColor end,
						get = function() return self.db.Color.r, self.db.Color.g, self.db.Color.b, self.db.Color.a end,
						set = function(_, red, green, blue, alpha)
							self.db.Color.r = red
							self.db.Color.g = green
							self.db.Color.b = blue
							self.db.Color.a = alpha
						end,
					},
				},
			},
		},
	}
	A.Options.args[self:GetName()] = DEFAULT_OT

	function self:SetTexture()
		local frame = AceGUI:Create("Frame")
		frame:SetCallback("OnClose", function(widget) AceGUI:Release(widget) end)
		frame:SetTitle(self:GetName().." - "..L.sc_gui_texture)
		frame:SetWidth(620)
		frame:SetHeight(500)

		local container = AceGUI:Create("SimpleGroup")
		container:SetRelativeWidth(1)
		container:SetHeight(400)
		container:SetLayout("Fill")
		frame:AddChild(container)

		local scroll = AceGUI:Create("ScrollFrame")
		scroll:SetLayout("Flow")
		container:AddChild(scroll)

		local count = 1
		for i, d in pairs(self.data.Texture) do
			local img = AceGUI:Create("Icon")
			img:SetCallback("OnClick", function() self.db.Texture = i end)
			img:SetImage(i)
			img:SetImageSize(64,64)
			scroll:AddChildren(img)
			count = count + 1
		end
	end
end

-- #######################################
-- #######################################

-- oninitialize
function AB:OnInitialize()
	self:CreateDataTableOptions()
	self:CreateSavedVariables()
	self:CreateDataTableGUIOptions()

	-- frameonupdate
	local Xpos, Ypos, Speed = 0, 0, 0
	function FrameOnUpdate(frame, elapsed)
		if self.db.Enable == true then
			local dXpos = Xpos
			local dYpos = Ypos
			Xpos, Ypos = GetCursorPosition()
			dXpos = Xpos - dXpos
			dYpos = Ypos - dYpos
			local Weight = 2048 ^ -elapsed
			Speed = math.min(Weight * Speed + (1 - Weight) * math.sqrt(dXpos * dXpos + dYpos * dYpos) / elapsed, 1024)
			local Size = Speed / 6 - 16
			if (Size > 0) then
				local Scale = UIParent:GetEffectiveScale()
				frame:SetFrameStrata(self.db.Strata)
				frame.Texture:SetTexture(self.db.Texture)
				frame.Texture:SetBlendMode(self.db.Blend)
				frame.Texture:SetHeight(Size)
				frame.Texture:SetWidth(Size)
				frame.Texture:SetPoint("CENTER", UIParent, "BOTTOMLEFT", (Xpos + 0.5 * dXpos) / Scale, (Ypos + 0.5 * dYpos) / Scale)
				if self.db.ClassColor == true then
					local _, englishClass, _ = UnitClass('player')
					frame.Texture:SetVertexColor(RAID_CLASS_COLORS[englishClass].r, RAID_CLASS_COLORS[englishClass].g, RAID_CLASS_COLORS[englishClass].b, 1)
					frame.Texture:SetDesaturated(true)
				elseif self.db.Desaturated == true then
					frame.Texture:SetVertexColor(self.db.Color.r, self.db.Color.g, self.db.Color.b, self.db.Color.a)
					frame.Texture:SetDesaturated(self.db.Desaturated)
				else
					frame.Texture:SetVertexColor(1, 1, 1, self.db.Color.a)
					frame.Texture:SetDesaturated(self.db.Desaturated)
				end
				frame.Texture:Show()
			else
				frame.Texture:Hide()
			end
		else
			frame.Texture:Hide()
		end
	end

	local Frame = CreateFrame("Frame")
	local StarTexture = Frame:CreateTexture()
	Frame.Texture = StarTexture
	Frame:SetParent(UIParent)
	Frame:SetScript("OnUpdate", FrameOnUpdate)
end